extends KinematicBody

var gravity = -9.8
var velocity = Vector3()
var camera

const SPEED = 6
const ACCELERATION = 3
const DE_ACCELERATION = 5


# Called when the node enters the scene tree for the first time.
func _ready():
#	camera = get_node("../Camera").get_global_transform()
	
	pass # Replace with function body.


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _physics_process(delta):
	var dir = Vector3()
	
	if (Input.is_action_pressed("forward")):
		dir += transform.basis[2]
		print("GO! " + String(dir))
	if (Input.is_action_pressed("back")):
		dir += -transform.basis[2]
		print("NO! " + String(dir))
	if (Input.is_action_pressed("left")):
		dir += transform.basis[0]
		print("LO! " + String(dir))
	if (Input.is_action_pressed("right")):
		dir += -transform.basis[0]
		print("RO! " + String(dir))
	
	dir.y = 0
	dir = dir.normalized()
	
	velocity.y += delta * gravity
	
	var hv = velocity
	hv.y = 0
	
	var new_pos = dir * SPEED
	var accel = DE_ACCELERATION
	
	if (dir.dot(hv) > 0):
		accel = ACCELERATION
	
	hv = hv.linear_interpolate(new_pos, accel * delta)
	
	velocity.x = hv.x
	velocity.z = hv.z
	
	velocity = move_and_slide(velocity, Vector3(0, 1, 0))
	
	
	
	
	
	
	
