extends KinematicBody

var gravity = Vector3.DOWN * 12  # strength of gravity

var speed = 2  # movement speed

var jump_speed = 4  # jump strength

var spin = 0.1  # rotation speed


var velocity = Vector3()
var jump = false




func get_input():
	jump = false
	if Input.is_action_just_pressed("jump"):
		jump = true  
		$AudioStreamPlayer.play()
	var vy = velocity.y  # DON'T UNDERSTAND!
	velocity = Vector3() # !!! TYPED ALREADY? REMOVE AND SEE...
	if Input.is_action_pressed("forward"):
		velocity += transform.basis.x * speed
	if Input.is_action_pressed("back"):
		velocity -= transform.basis.x * speed
	if Input.is_action_pressed("right"):
		velocity += transform.basis.z * speed
	if Input.is_action_pressed("left"):
		velocity -= transform.basis.z * speed
	velocity.y = vy  # DON'T UNDERSTAND!










func _unhandled_input(event):
	if event is InputEventMouseMotion  and Input.get_mouse_mode() == Input.MOUSE_MODE_CAPTURED:
		if event.relative.x > 0:
			rotate_y(lerp(0, -spin, event.relative.x/10)) # Research LERP code syntax
		elif event.relative.x < 0:
			rotate_y(lerp(0, -spin, event.relative.x/10)) # Research LERP code syntax


func _input(event):
	if event.is_action_pressed("ui_cancel"):
		Input.set_mouse_mode(Input.MOUSE_MODE_VISIBLE)
	if event.is_action_pressed("jump"):
		if Input.get_mouse_mode() == Input.MOUSE_MODE_VISIBLE:
			Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED)
			get_tree().set_input_as_handled()
			




func _physics_process(delta):
	velocity += gravity * delta # add gravity to accelerate in the positive Y direction (downward)
	get_input() # check for input/see which key is pressed
	velocity = move_and_slide(velocity, Vector3.UP) # move in the direction of the velocity vector
	if jump and is_on_floor():
		velocity.y = jump_speed
	
	
		
	
